package com.map;




import java.util.List;


import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Point;
import android.os.Bundle;

import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.Toast;




import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;

import com.google.android.maps.MapView.LayoutParams;

public class AddPoint extends MapActivity {
	MapView mapView; 
    MapController mc;
    GeoPoint p;
    int status =0;
    //String Number = "";
    

    class MapOverlay extends com.google.android.maps.Overlay
    {
        @Override
        public boolean draw(Canvas canvas, MapView mapView, 
        boolean shadow, long when) 
        {
            super.draw(canvas, mapView, shadow);                   
 
            //---translate the GeoPoint to screen pixels---
            Point screenPts = new Point();
            mapView.getProjection().toPixels(p, screenPts);
 
            //---add the marker---
            Bitmap bmp = BitmapFactory.decodeResource(
                getResources(), R.drawable.pushpin);            
            canvas.drawBitmap(bmp, screenPts.x, screenPts.y-50, null);   
            //canvas.drawLines(mPts, paint);
            return true;
        }
        
        @Override
        public boolean onTouchEvent(MotionEvent event, MapView mapView) 
        {   
            //---when user lifts his finger---
            if (event.getAction() == 1) {                
                GeoPoint p1 = mapView.getProjection().fromPixels(
                    (int) event.getX(),
                    (int) event.getY());
                    
                    if(1== status){
                    	GlobalData globalData = GlobalData.getInstance();
                    	globalData.lat =Double.toString(p1.getLatitudeE6() / 1E6);
                    	globalData.lng =Double.toString(p1.getLongitudeE6() / 1E6);
                    	Toast.makeText(getBaseContext(), 
                    			globalData.lat + "," + 
                    			globalData.lng , 
                                Toast.LENGTH_SHORT).show();
                    	startActivity(new Intent(getBaseContext(), CreateRouteForm.class));
//                    	Intent intent = new Intent(getBaseContext(),CreateRouteForm.class);  
//                    	startActivity(intent);
                    	
                    	AddPoint.this.finish();
                    }
                   
                    
            }                            
            return false;
        }   
        
    }
    
    OnClickListener addButtonListener = new OnClickListener(){		

		public void onClick(View v)
		{
			status =1;	
		}	
		
	};
	OnClickListener backButtonListener = new OnClickListener(){		

		public void onClick(View v)
		{
			startActivity(new Intent(getBaseContext(), map.class));
			AddPoint.this.finish();
			
		}	
		
	};
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.addpoint);

// 
        mapView = (MapView) findViewById(R.id.mapView);
        LinearLayout zoomLayout = (LinearLayout)findViewById(R.id.zoom);  
        View zoomView = mapView.getZoomControls(); 
 
        zoomLayout.addView(zoomView, 
            new LinearLayout.LayoutParams(
                LayoutParams.WRAP_CONTENT, 
                LayoutParams.WRAP_CONTENT)); 
        mapView.displayZoomControls(true);
        
        mc = mapView.getController();
        //init position 
        String coordinates[] = {"61.064535", "28.095353"};
        double lat = Double.parseDouble(coordinates[0]);
        double lng = Double.parseDouble(coordinates[1]);
 
        p = new GeoPoint(
            (int) (lat * 1E6), 
            (int) (lng * 1E6));
 
        mc.animateTo(p);
        mc.setZoom(17); 
        
        //---Add a location marker---
        MapOverlay mapOverlay = new MapOverlay();
        List<Overlay> listOfOverlays = mapView.getOverlays();
        listOfOverlays.clear();
        listOfOverlays.add(mapOverlay);        
        
        Button button = (Button)findViewById(R.id.AddButton);
        button.setOnClickListener(addButtonListener);
        Button serviceButton = (Button)findViewById(R.id.BackButton);
        serviceButton.setOnClickListener(backButtonListener);
        
        mapView.invalidate();
      
 
    }

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}

}
