package com.map;

import java.util.ArrayList;
import java.util.List;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.drawable.Drawable;
import android.view.MotionEvent;
import android.widget.Toast;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

public class MyItemizedOverlay extends ItemizedOverlay {

	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	private Context mContext;

	public MyItemizedOverlay(Drawable defaultMarker) {
		super(defaultMarker);
		  //super(boundCenterBottom(defaultMarker));
		}
	
	public MyItemizedOverlay(Drawable defaultMarker, Context context) {
		  //super(defaultMarker);
		super(boundCenterBottom(defaultMarker));
		  mContext = context;
		}
	
	@Override
	protected boolean onTap(int index) {
	  OverlayItem item = mOverlays.get(index);
	  AlertDialog.Builder dialog = new AlertDialog.Builder(mContext);
	  dialog.setTitle(item.getTitle());
	  dialog.setMessage(item.getSnippet());
	  dialog.setNegativeButton("CANCEL", new DialogInterface.OnClickListener() {
	      public void onClick(DialogInterface dialog, int which) {
	        return;
	      } }); 
	  dialog.setPositiveButton("DELETE", new DialogInterface.OnClickListener() {
	      public void onClick(DialogInterface dialog, int which) {
	        return;
	      }}); 


	  dialog.show();
	  return true;
	}
	
//	 @Override
//     public boolean onTouchEvent(MotionEvent event, MapView mapView) 
//     {   
//         //---when user lifts his finger---
//         if (event.getAction() == 1) {                
//             GeoPoint p1 = mapView.getProjection().fromPixels(
//                 (int) event.getX(),
//                 (int) event.getY());
//                 Toast.makeText(mContext, 
//                     p1.getLatitudeE6() / 1E6 + "," + 
//                     p1.getLongitudeE6() /1E6 , 
//                     Toast.LENGTH_SHORT).show();
//                 List<Overlay> mapOverlays = mapView.getOverlays();
//                 Drawable drawable = mContext.getResources().getDrawable(R.drawable.point);
//                 
//                MyItemizedOverlay itemizedoverlay = new MyItemizedOverlay(drawable, mContext);
//                OverlayItem overlayitem = new OverlayItem(p1, "Test!", "I'm must be here!");
//                 itemizedoverlay.addOverlay(overlayitem);
//                 mapOverlays.add(itemizedoverlay);
//                 mapView.invalidate();
//                 
//
//                 
//         }                            
//         return false;
//     }   
	
	
	public void addOverlay(OverlayItem overlay) {
	    mOverlays.add(overlay);
	    populate();
	}

	
	
	@Override
	protected OverlayItem createItem(int i) {
	  return mOverlays.get(i);
	}


	@Override
	public int size() {
		return mOverlays.size();
	}

}
