package com.map;

public class Neuron{
	
	// Neuron's inputs count
	protected int		inputsCount = 0;
	
	// Nouron's wieghts
	protected double[]	weights = null;
	
	// Neuron's output value
	protected double	output = 0;
	
	// Random number generator
	protected double	rand = 0.0;
	
	// Random generator range
	protected static DoubleRange randRange = new DoubleRange( 0.0, 1.0 );
	
	// Random generator range
	public static DoubleRange getRandRange(){
		return randRange;
	}
	public static void setRandRange(DoubleRange value){
		if ( value != null )
			randRange = value;		
	}
	
	// Neuron's inputs count
	public int getInputsCount(){
		return inputsCount;
	}
	
	// Neuron's output value
	public double getOutput(){
		return output;
	}
	
	// Randomize neuron
	public void Randomize( )
	{
		double d = randRange.getLength();
		for ( int i = 0; i < inputsCount; i++ )
			weights[i] = Math.random() * d + randRange.getMin();
	}
	
	// Initializes a new instance
	public Neuron( int inputs ) { 
		inputsCount = Math.max( 1, inputs );
		weights = new double[inputsCount];
		Randomize( );
    }	
	
	// Computes output value of neuron
	public double Compute( double[] input )
	{
		output = 0.0;
		for ( int i = 0; i < inputsCount; i++ )
		{
			output += Math.abs( weights[i] - input[i] );
		}
		return output;
	}}
