package com.map;


import java.util.List;




import com.google.android.maps.GeoPoint;


import android.content.Intent;
import android.database.Cursor;
import android.graphics.Canvas;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;

import android.graphics.drawable.Drawable;
import android.os.Bundle;

import com.google.android.maps.MapView.LayoutParams;  


import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.LinearLayout;





public class map extends MapActivity 
{    
    MapView mapView; 
    MapController mc;
    GeoPoint p;
    GeoPoint[] Pts;

    

    class MapOverlay extends com.google.android.maps.Overlay
    {
    	@Override
        public boolean draw(Canvas canvas, MapView mapView, 
        boolean shadow, long when) 
        {
            super.draw(canvas, mapView, shadow);                   
 
            //---translate the GeoPoint to screen pixels---
            Point screenPts = new Point();
            Point screenPts1 = new Point();
            mapView.getProjection().toPixels(p, screenPts);
 
            //---add the marker---
            Bitmap bmp = BitmapFactory.decodeResource(
                getResources(), R.drawable.pushpin);            
            canvas.drawBitmap(bmp, screenPts.x, screenPts.y, null);  
            

            Paint paint = new Paint();
            paint.setColor(Color.RED);
            paint.setStrokeWidth(5);
            

            GeoPoint p1 = null, p0 = null;
            DBAdapter db;
            db = new DBAdapter(getBaseContext()); 
            db.open();
            double lat;
        	double lng;
            Cursor c = db.fetchAllAddress();
            int i=0;
            if (c.moveToFirst())
            {
                do {
                	//mRowId, str, pc, lt, nb
                	lat = Double.parseDouble(c.getString(3));
                	lng = Double.parseDouble(c.getString(2));
                	if(0==i){
                		mapView.getProjection().toPixels(p, screenPts);
                		i=1;
                	}else{
                		p0= p1;
                    	
                    	mapView.getProjection().toPixels(p0, screenPts);
                	}
                	p1 = new GeoPoint(
                			(int) (lat * 1E6), 
                			(int) (lng * 1E6));
                	mapView.getProjection().toPixels(p1, screenPts1);
                	
                	canvas.drawLine(screenPts.x, screenPts.y, screenPts1.x, screenPts1.y, paint);
                	i++;

                } while (c.moveToNext());
                if (i>1){
                mapView.getProjection().toPixels(p1, screenPts);
            	mapView.getProjection().toPixels(p, screenPts1);
                canvas.drawLine(screenPts.x, screenPts.y, screenPts1.x, screenPts1.y, paint);
                }
            }
            db.close();

            return true;
        }  
               
        
    } 

   
	

 
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
 
 
        mapView = (MapView) findViewById(R.id.mapView);
        LinearLayout zoomLayout = (LinearLayout)findViewById(R.id.zoom);  
        View zoomView = mapView.getZoomControls(); 
 
        zoomLayout.addView(zoomView, 
            new LinearLayout.LayoutParams(
                LayoutParams.WRAP_CONTENT, 
                LayoutParams.WRAP_CONTENT)); 
        mapView.displayZoomControls(true);
        
        mc = mapView.getController();
        //init position 
        String coordinates[] = {"61.064535", "28.095353"};
        double lat = Double.parseDouble(coordinates[0]);
        double lng = Double.parseDouble(coordinates[1]);
 

        
        List<Overlay> mapOverlays = mapView.getOverlays();
        Drawable drawable = this.getResources().getDrawable(R.drawable.point);
        
       MyItemizedOverlay itemizedoverlay = new MyItemizedOverlay(drawable, this);

        
        OverlayItem overlayitem ;
        GeoPoint p1;
        DBAdapter db;
        db = new DBAdapter(this); 
        db.open();
        int i=0;
        Cursor c = db.fetchAllAddress();
        MapOverlay mapOverlay = new MapOverlay();
        List<Overlay> listOfOverlays = mapView.getOverlays();
        listOfOverlays.clear();
        if (c.moveToFirst())
        {
            do {
            	//mRowId, str, pc, lt, nb
            	lat = Double.parseDouble(c.getString(3));
            	lng = Double.parseDouble(c.getString(2));
            	
            	if (i==0){
            		
            		 p = new GeoPoint(
            		            (int) (lat * 1E6), 
            		            (int) (lng * 1E6));
            		 
    		        mc.animateTo(p);
    		        mc.setZoom(17); 

    		        i=1;
    		        continue;
            	}
            	p1 = new GeoPoint(
            			(int) (lat * 1E6), 
            			(int) (lng * 1E6));
            	overlayitem = new OverlayItem(p1, c.getString(1), "Route!");
        		itemizedoverlay.addOverlay(overlayitem);
        		
            } while (c.moveToNext());
        }
        db.close();
        if (0==i){
            lat = Double.parseDouble("61.064535");
            lng = Double.parseDouble("28.095353");
     
            p = new GeoPoint(
                (int) (lat * 1E6), 
                (int) (lng * 1E6));
     
            mc.animateTo(p);
            mc.setZoom(17); 
        }
        mapOverlays.add(itemizedoverlay);
        listOfOverlays.add(mapOverlay); 


     
        
        mapView.invalidate();

 
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu, menu);
        return true;
    }
     
    
    
    
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.icon:     
            	startActivity(new Intent(this, OptimRoute.class));
                                break;
            case R.id.icontext: 
            					startActivity(new Intent(this, ViewAddresses.class));
                                break;
            case R.id.add: 
            					startActivity(new Intent(this, AddPoint.class));
            					this.finish();
				                break;
            case R.id.exit: 
            					this.finish();
				                break;
        }
        return true;
    }
 
    @Override
    protected boolean isRouteDisplayed() {
        // TODO Auto-generated method stub
        return false;
    }
}

